/**********************************************************************************************
	* Snowball VFX
	*
	* AppDisplay - visual appdata and other stuff
	* Version 0.1
	* Created by: Matan Halberstadt
	* Last update: 5/17/2011 4:55:20 PM
**********************************************************************************************/

(
	global rollout_AppDisplay
	try (destroyDialog rollout_AppDisplay) catch ()
	rollout rollout_AppDisplay "AppDisplay"
	(
	-- Local Structs
	-----------------------------------------
	
	struct s_DotNetCollection
	(
		c_Color = dotnetclass "System.Drawing.Color",
		c_String = dotNetClass "System.String",
		c_Int32 = dotNetClass "System.Int32",
		c_Image = dotNetclass "System.Drawing.image",
		c_FlatStyle = dotNetclass "System.Windows.Forms.FlatStyle",	
		c_ToolItemDisplayStyle = dotnetclass "System.Windows.Forms.ToolStripItemDisplayStyle",  
		c_ColorDepth = dotnetclass "System.Windows.Forms.ColorDepth",
		c_GridTriState = dotnetclass "System.Windows.Forms.DataGridViewTriState",
		c_GridAutoSizeRows = dotnetclass "System.Windows.Forms.DataGridViewAutoSizeRowsMode",
		c_GridEditMode = dotNetClass "System.Windows.Forms.DataGridViewEditMode",
		c_DockStyle = dotnetclass "System.Windows.Forms.DockStyle",
		c_GridAutoSizeCols = dotnetclass "System.Windows.Forms.DataGridViewAutoSizeColumnsMode",
		c_GridColHeadersHMode = dotnetclass "System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode",
		c_GridAlign = dotnetclass "System.Windows.Forms.DataGridViewContentAlignment",
		
		fn dnColor c = 
		(
			if c == #Empty then
				c_Color.Empty
			else
				c_Color.fromARGB c.a c.r c.g c.b
		),
		
		fn HitTest ctl location PointToClient:false = 
		(
			local pt = location
			if PointToClient then pt = ctl.PointToClient location
			local PointedCell = (ctl.HitTest pt.x  pt.y)
		),
		
		fn GetSelectedRows ctl location: = 
		(
			local selectedRows = #()
			
			if ctl.SelectedRows.count > 0 then (
				local last = (ctl.SelectedRows.count - 1)
				for i = 0 to last do (
					local RowIndex = ctl.SelectedRows.item[i].Index
					append selectedRows RowIndex
				)
			) else if ctl.SelectedCells.count > 0 then (
				local last = (ctl.SelectedCells.count - 1)
				for i = 0 to last do (
					local RowIndex = ctl.SelectedCells.item[i].RowIndex
					if (findItem selectedRows RowIndex) == 0 then append selectedRows RowIndex
				)
			) 
			
			if  location != unsupplied then (
				local PointedCell = HitTest ctl location PointToClient:true
				local RowIndex = PointedCell.RowIndex
				if RowIndex >= 0 then (
					if (findItem selectedRows RowIndex) == 0 then selectedRows = #(RowIndex)
				)
			)
			
			selectedRows
		),
		
		fn dnArray mxsArray = 
		(
			local netArray = dotNetObject "System.String[]" mxsArray.count
			 
			for i = 1 to mxsArray.count do (
				str = dotNetObject "System.String" (mxsArray[i] as string)
				indx = dotNetObject "System.Int32" (i - 1)
				netArray.SetValue str indx
			)
			
			netArray
		),
		
		fn GetCell ctl ColumnIndex RowIndex = 
		(
			ctl.item ColumnIndex RowIndex
		),
		
		fn dnSize Width Height = 
		(
			dotNetObject "Drawing.Size" Width Height
		),
		
		fn Type dnObj = 
		(
			local cls = classof dnObj
			if cls == dotNetObject or cls == dotNetClass or cls == dotNetControl then dotNet.getType dnObj
			else cls
		),
		
		fn Image imgPath Dir:"" = 
		(
			if imgPath != undefined then (
				if (Type imgPath == Type c_Bitmap) then return imgPath
				else if isKindOf imgPath string and imgPath != "" do (
					if Dir != undefined and Dir != unsupplied then imgPath = Dir + imgPath
					if doesFileExist imgPath do return (c_Image.fromfile imgPath) 
				)
			)
			undefined
		),
		
		fn AddImages ctl images Keys: Dir: = 
		(
			local success = true
			if not (isKindOf images array) then (
				local img = Image images Dir:Dir
				if img != undefined then (
					if Keys != unsupplied then ctl.Images.Add (Keys as string) img
					else if isKindOf images string then ctl.Images.Add (getFilenameFile images) img
					else ctl.Images.Add img
				) else success = false
			) else (
				if Keys != unsupplied and Keys.count == images.count then (
					for i=1 to images.count do (
						local img = Image images[i] Dir:Dir
						if img != undefined do ctl.Images.Add (Keys[i] as string) img
					)
				) else (
					for i=1 to images.count do (
						local img = Image images[i] Dir:Dir
						if img != undefined then (
							if (isKindOf images[i] string) then ctl.Images.Add (getFilenameFile images[i]) img
							else ctl.Images.Add img
						)
					)
				)
			)
			success
		),
		
		fn ImageList images Width:32 Height:32 bitDepth: TransparentColor: Keys: Dir:"" = 
		(
			if bitDepth == unsupplied then
				bitDepth = c_ColorDepth.Depth32Bit
			local imageList = dotNetObject "System.Windows.Forms.ImageList" 
			imageList.ColorDepth = bitDepth
			imageList.ImageSize = dnSize Width Height
			if TransparentColor != unsupplied then
				imageList.TransparentColor = dnColor TransparentColor
			else
				imageList.TransparentColor = dnColor #Empty
			AddImages imageList images Keys:Keys Dir:Dir
			imageList
		),
		
		fn setListItems ctl list =
		(
			case of
			(
				(hasProperty ctl "Items"): (
					ctl.Items.Clear()
					ctl.Items.AddRange (dnArray list)
				)
				(hasProperty ctl "DropDownItems"): (
					ctl.DropDownItems.Clear()
					ctl.DropDownItems.AddRange list
				)
				default: ()
			)
		),
		
		fn ToolBarItem kind:#Button title: cname: width: height: image: imageKey: imageIndex: displayStyle: check: Checked: lblSpring: tooltip: list: enabled: FontName: FontSize: style: foreColor: AutoSize: = 
		(
			local item = dotNetObject ("System.Windows.Forms.ToolStrip" + (kind as string))
			
			if title != unsupplied do item.text = title
			if title != unsupplied or cname != unsupplied do item.name = (if cname != unsupplied then cname else title)
			if Width != unsupplied then  item.Width = Width
			if Height != unsupplied then item.Height = Height
			if image != unsupplied then item.image = image
			if displayStyle != unsupplied then item.DisplayStyle = displayStyle
			if check != unsupplied then item.CheckOnClick = check
			if Checked != unsupplied then item.Checked = Checked
			if lblSpring != unsupplied then item.Spring = lblSpring 
			if lblSpring	== true then item.TextAlign = c_Align.MiddleLeft
			if tooltip != unsupplied then item.ToolTipText = tooltip
			if enabled != unsupplied then item.Enabled = enabled
			if list != unsupplied then setListItems item list
			if imageKey != unsupplied then item.ImageKey = imageKey
			if imageIndex != unsupplied then item.ImageIndex = imageIndex
			if FontName != unsupplied or FontSize != unsupplied or style != unsupplied do item.Font = (Font FontName FontSize style ctl:item)
			if ForeColor != unsupplied do item.ForeColor = (dnColor ForeColor)
			if AutoSize != unsupplied do item.AutoSize = AutoSize
			
			item
		),
		
		fn AddItems ctl items = 
		(
			if iskindof items array then (for item in items do ctl.Items.Add item)
			else ctl.Items.Add items
		),
		
		fn ToolBar LayoutStyle: tbItems: Width: Height: imagelist: ImageWidth: ImageHeight: backColor: AutoSize: Dock: = 
		(
			local tbNew =  dotNetObject "System.Windows.Forms.ToolStrip"
			
			if Width != unsupplied then tbNew.Width = Width
			if Height != unsupplied then tbNew.Height = Height
			if LayoutStyle != unsupplied do tbNew.LayoutStyle = LayoutStyle
			if tbItems != unsupplied do AddItems tbNew tbItems
			if imagelist != unsupplied then (tbNew.ImageList = imagelist ; tbNew.ImageScalingSize = imagelist.ImageSize)
			if ImageWidth != unsupplied and ImageHeight != unsupplied then tbNew.ImageScalingSize = (dnSize ImageWidth ImageHeight)
			if backColor != unsupplied then tbNew.BackColor = (dnColor backColor)
			if AutoSize != unsupplied do tbNew.AutoSize = AutoSize
			if Dock != unsupplied do tbNew.dock = dock	
			
			tbNew
		),
		
		fn StatusBar sItems: Width: Height: backColor: = 
		(
			local sNew =  dotNetObject "System.Windows.Forms.StatusStrip"
			
			if sItems != unsupplied do AddItems sNew sItems
			if Width != unsupplied then sNew.Width = Width
			if Height != unsupplied then sNew.Height = Height
			if backColor != unsupplied then sNew.BackColor = (dnColor backColor)
			
			sNew
		),
		
		fn InitGrid ctl Width: Height: pos: virtual:false rowHeaders:true columnHeaders:true rowHeight: backColor: ScrollBars: Dock: CellBorderStyle: AutoSizeCols: = 
		(
			if Width != unsupplied then  ctl.Width = Width
			if Height != unsupplied then ctl.Height = Height
			if pos != unsupplied then ctl.Location = dnPoint pos.x pos.y
			ctl.AllowUserToAddRows = false
			ctl.AllowUserToDeleteRows	= false	
			ctl.AllowUserToOrderColumns = true
			ctl.EditMode = c_GridEditMode.EditOnEnter
			ctl.VirtualMode = virtual
			ctl.ColumnHeadersHeightSizeMode = c_GridColHeadersHMode.AutoSize
			ctl.ColumnHeadersDefaultCellStyle.alignment = c_GridAlign.TopCenter
			ctl.RowHeadersVisible = rowHeaders
			ctl.ColumnHeadersVisible = columnHeaders
			if rowHeight != unsupplied do ctl.RowTemplate.height = rowHeight
			if backColor  != unsupplied do ctl.backgroundColor = dnColor backColor 
			if ScrollBars != unsupplied do ctl.ScrollBars = ScrollBars 
			if Dock != unsupplied do ctl.dock = dock
			if CellBorderStyle != unsupplied do ctl.CellBorderStyle = CellBorderStyle
			if AutoSizeCols != unsupplied do ctl.AutoSizeColumnsMode = AutoSizeCols
		),
		
		fn GridView Width: Height: pos: virtual:false rowHeaders:true columnHeaders:true rowHeight: backColor: ScrollBars: Dock: CellBorderStyle: AutoSizeCols: = 
		(
			local ctlNew =  dotNetObject "System.Windows.Forms.DataGridView" 
			InitGrid ctlNew Width:Width Height:Height pos:pos	virtual:virtual rowHeaders:rowHeaders columnHeaders:columnHeaders rowHeight:rowHeight backColor:backColor ScrollBars:ScrollBars Dock:Dock CellBorderStyle:CellBorderStyle AutoSizeCols:AutoSizeCols
			ctlNew
		),
		
		fn AddControls ctl controls = 
		(
			if isKindOf controls array then (for c in controls do ctl.controls.add c)
			else ctl.controls.add controls
		),
		
		fn GridAddColumn ctl title cname: kind:#TextBox type:c_String visible:true width:100 readOnly:false frozen:false list: flatstyle: resizable:true = 
		(
			local col = dotNetObject ("System.Windows.Forms.DataGridView" + (kind as string) + "Column")
			col.headerText = title
			col.Name = (if cname != unsupplied then cname else title)
			ctl.columns.add col
			
			if classof resizable == BooleanClass then (
				if resizable then
					resizable = c_GridTriState.true
				else
					resizable = c_GridTriState.false
			)
			
			col.toolTipText = title
			
			if type != undefined then col.valueType = type
			if visible != undefined then col.visible = visible
			if width != undefined then col.width = width
			if readOnly != undefined then col.readOnly = readOnly
			if frozen != undefined then col.frozen = frozen
			if kind == #ComboBox and list != unsupplied then setListItems col list
			if flatstyle != unsupplied and flatstyle != undefined then col.FlatStyle = flatstyle
			if resizable != undefined then col.resizable = resizable
			
			col
		),
		
		fn InitToolBarContainer ctl Dock: TopPanel: BottomPanel: LeftPanel:  RightPanel: ContentPanel: backColor: = 
		(
			if Dock != unsupplied do ctl.dock = dock
			if TopPanel != unsupplied do AddControls ctl.TopToolStripPanel TopPanel
			if BottomPanel != unsupplied do AddControls ctl.BottomToolStripPanel BottomPanel
			if LeftPanel != unsupplied do AddControls ctl.LeftToolStripPanel LeftPanel
			if RightPanel != unsupplied do AddControls ctl.RightToolStripPanel RightPanel
			if ContentPanel != unsupplied do AddControls ctl.ContentPanel ContentPanel
			if backColor != unsupplied then ctl.BackColor = (dnColor backColor)
		)
	)
	
	struct s_rowData
	(
		rowLabel,
		val,
		keyColor,
		mat,
		renderable = true,
		primaryVisibility = true,
		objs = #()
	)
	
	struct s_objectData
	(
		obj,
		wire,
		mat,
		renderable,
		primaryVisibility,
		
		fn init =
		(
			if isValidNode obj then (
				wire = obj.wirecolor
				mat = obj.material
				renderable = obj.renderable
				primaryVisibility = obj.primaryVisibility
			)
			
			true
		),
		
		fn recover mats:false =
		(
			if isValidNode obj then (
				obj.wirecolor = wire
				obj.renderable = renderable
				obj.primaryVisibility = primaryVisibility
				if mats then
					obj.material = mat
			)
		),
		
		fill = init()
	)
	
	struct s_gridColumn
	(
		title,
		kind,
		type,
		width,
		flatStyle = unsupplied
	)
	
	struct s_prop_Abstruct
	(
		Rows = #(),
		initialized = false,
		editLabels = false,
		canAdd = false,
		canTimeUpdate = false,
		materialsMode = false,
		flags = #(),
		gradColors = #(blue, green, red),
		inBetweens = 10,
		
		fn getFilters =
		(
			flags
		),
		
		fn generateGrads =
		(
			for i = 1 to Rows.count do (
				if Rows[i].keyColor == undefined then (
					local j = i - 1
					while(Rows[j].keyColor == undefined and j > 1) do
						j -= 1
					
					local k = i + 1
					while(Rows[k].keyColor == undefined and k < Rows.count) do
						k += 1
					
					Rows[i].keyColor = Rows[j].keyColor * (k - i) / (k - j) + Rows[k].keyColor * (i - j) / (k - j)
				)
			)
		),
		
		fn getRowsByFilter filt =
		(
			if classOf filt == String then (
				filt = "*" + filt + "*"
				for i = 1 to Rows.count where matchPattern Rows[i].rowLabel pattern:filt collect i
			) else
				#()
		),
		
		fn init objs:objects forced:false =
		(
			if not initialized or forced then (
				Rows = #()
				
				initialized = true
			)
		),
		
		fn getRows =
		(
			local newRows = #()
			if Rows.count > 0 then (
				for i = 1 to Rows.count do (
					append newRows #()
					append newRows[i] Rows[i].rowLabel
					append newRows[i] Rows[i].objs.count
					append newRows[i] Rows[i].keyColor
				)
			)
			
			newRows
		),
		
		fn setValue row objs =
		(
			row += 1
		),
		
		fn addRow =
		(
			
		),
		
		fn setLabel row newLabel =
		(
			
		),
		
		fn createMaterials =
		(
			for Row in Rows do
				Row.objs.material = standardMaterial diffuse:Row.keyColor
		),
		
		fn done =
		(
			
		)
	)
	
	struct s_prop_Default
	(
		Base = rollout_AppDisplay.s_prop_Abstruct(),
		
		fn getFilters =
		(
			Base.getFilters()
		),
		
		fn init objs:objects forced:false =
		(
			if not Base.initialized or forced then (
				Base.Rows = #()
				Base.initialized = true
			)
		),
		
		fn getRows =
		(
			Base.getRows()
		),
		
		fn setValue row objs =
		(
			row += 1
		),
		
		fn addRow =
		(
			Base.addRow()
		),
		
		fn setLabel row newLabel =
		(
			Base.setLabel row newLabel
		),
		
		fn createMaterials =
		(
			Base.createMaterials()
		),
		
		fn done =
		(
			Base.done()
		)
	)
	
	-- Global Variable Declerations
	------------------------------------------
	
		global objectsData
	
	-- Local Variable Declerations
	------------------------------------------
		
		local pluginsPath = (getDir #userScripts) + "\\Snowball_Tools\\AppDisplay\\Moduls\\"
		local iconsPath = (getDir #userScripts) + "\\Snowball_Tools\\AppDisplay\\UI\\"
		local icons = #("toggleDisplay.png ", "toggleMaterial.png ", "toggleIdentity.png ", "refresh.png", "select.png", "add.png", "toggleTimeUpdate.png")
		local DN = s_DotNetCollection()
		
		local ROLL_WIDTH = 310
		local ROLL_HEIGHT = 467
		local ROLL_STYLE = #(#style_border, #style_titlebar, #style_minimizebox, #style_maximizebox, #style_sysmenu, #style_resizing)
		local CATEGORIES
		local SCENESTATE_FLAGS = #{3, 8}
		local VIEWPRT_RENDER_FLAG = viewport.GetRenderLevel()
		
		local dgvObjectsGrid, gridColumns, gridRows, strpStatusBar, strpControls, strpControlsItems, strpStatusBarItems, iconsList
		local Prop, pluginStructs
		local lastDisplayMode
		
	
	-- User Interface
	------------------------------------------
		
		dotNetControl tscMainWrapper "System.Windows.Forms.ToolStripContainer" width:ROLL_WIDTH height:(ROLL_HEIGHT - 25) pos:[0,0]
		hyperLink sbLink "Snowball studios" address:"http://www.snowballvfx.com" color:blue hoverColor:yellow visitedColor:(color 102 0 161) align:#left
		hyperLink matanLink "Matan Halberstadt" address:"http://www.cargocollective.com/matan" color:blue hoverColor:yellow visitedColor:(color 102 0 161) align:#right offset:[0,-20]
		
	-- Functions
	------------------------------------------
		
		fn getObjects =
		(
			for o in objects where not o.isHidden collect o
		)
		
		fn getToolbarItem title =
		(
			strpControls.items.item title
		)
		
		fn getStatusbarItem title =
		(
			strpStatusBar.items.item title
		)
		
		fn getCell col row =
		(
			gridRows[row + 1][col + 1]
		)
		
		fn setCell col row val =
		(
			gridRows[row + 1][col + 1] = val
		)
		
		fn clearGrid =
		(
			dgvObjectsGrid.Rows.Clear()
		)
		
		fn updateGrid =
		(
			clearGrid()
			dgvObjectsGrid.RowCount = gridRows.count 
		)
		
		fn setPrograssMax m =
		(
			local p = getStatusbarItem "Prograss"
			p.Maximum = m
			p.Step = 1
		)
		
		fn stepPrograss =
		(
			(getStatusbarItem "Prograss").PerformStep()
		)
		
		fn resetPrograss =
		(
			(getStatusbarItem "Prograss").Value = 0
		)
		
		fn dgvObjectsGrid_CellValueNeeded arg =
		(
			if Prop.Base.Rows.count > 0 and arg.RowIndex < Prop.Base.Rows.count then (
				local val = getCell arg.ColumnIndex arg.RowIndex
				if isKindOf val color then (
					arg.Value = undefined
					(dgvObjectsGrid.item arg.ColumnIndex arg.RowIndex).Style.BackColor = DN.dnColor (getCell arg.ColumnIndex arg.RowIndex)
				) else
					arg.Value = getCell arg.ColumnIndex arg.RowIndex
			)
		)
		
		fn dgvObjectsGrid_CellValuePushed arg = 
		(
			setCell arg.ColumnIndex arg.RowIndex arg.value
		)
		
		fn initColumns =
		(
			gridColumns = #()
			append gridColumns (s_gridColumn title:"Label" kind:#TextBox type:DN.c_String width:130)
			append gridColumns (s_gridColumn title:"Count" kind:#TextBox type:DN.c_Int32 width:50)
			append gridColumns (s_gridColumn title:"Color" kind:#Button type:DN.c_Image width:50 flatStyle:DN.c_FlatStyle.popup)
		)
		
		fn saveObjectsData objs:objects =
		(
			objectsData = #()
			for o in objs do
				append objectsData (s_objectData obj:o)
		)
		
		fn recoverObjectsData mats:false =
		(
			if Prop != undefined and isProperty Prop #done then
				Prop.done()
			
			resetPrograss()
			setPrograssMax objectsData.count
			for o in objectsData do (
				o.recover mats:mats
				stepPrograss()
			)
			resetPrograss()
			
			displayColor.shaded = #material
			viewport.SetRenderLevel VIEWPRT_RENDER_FLAG
		)
		
		fn getDisplayMode =
		(
			case of
			(
				((getToolbarItem "V").Checked): 1
				((getToolbarItem "M").Checked): 2
				((getToolbarItem "I").Checked): 3
				default:0
			)
		)
		
		fn setDisplayMode mode =
		(
			local states = case mode of
			(
				1: #{1}
				2: #{2}
				3: #{3}
				default: #{}
			)
			
			(getToolbarItem "V").Checked = states[1]
			(getToolbarItem "M").Checked = states[2]
			(getToolbarItem "I").Checked = states[3]
		)
		
		fn visualize =
		(
			setDisplayMode 1
			
			viewport.SetRenderLevel #flat
			displayColor.shaded = #object
			
			for r = 1 to Prop.Base.Rows.count do
				Prop.Base.Rows[r].objs.wirecolor = Prop.Base.Rows[r].keyColor
		)
		
		fn toggleDisplay sender arg objs:(getObjects()) =
		(
			if sender.Checked then (
				visualize()
			) else if getDisplayMode() == 0 then
				recoverObjectsData()
		)
		
		fn toggleMaterials sender arg objs:(getObjects()) =
		(
			if sender.Checked then (
				setDisplayMode 2
				
				viewport.SetRenderLevel #flat
				displayColor.shaded = #object
				
				Prop.createMaterials()
				for r in Prop.Base.Rows do (
					r.objs.renderable = r.renderable
					r.objs.primaryVisibility = r.primaryVisibility
				)
			) else
				recoverObjectsData mats:true
		)
		
		fn toggleIdentity sender arg objs:(getObjects()) =
		(
			if sender.Checked then (
				setDisplayMode 3
				
				viewport.SetRenderLevel #flat
				displayColor.shaded = #object
				
				local rowIndexes = DN.GetSelectedRows dgvObjectsGrid
				for r = 1 to Prop.Base.Rows.count do
					Prop.Base.Rows[r].objs.wirecolor = if findItem rowIndexes (r - 1) > 0 then white else black
			) else if getDisplayMode() == 0 then
				recoverObjectsData()
		)
		
		fn toggleTimeUpdate sender arg =
		(
			if sender.Checked then
				registerTimeCallback rollout_AppDisplay.refreshList
			else
				unRegisterTimeCallback rollout_AppDisplay.refreshList
		)
		
		fn updateDisplay =
		(
			local arg = undefined
			
			case getDisplayMode() of 
			(
				(1): toggleDisplay (getToolbarItem "V") arg
				(2): toggleMaterials (getToolbarItem "M") arg
				(3): toggleIdentity (getToolbarItem "I") arg
				default: (
					viewport.SetRenderLevel VIEWPRT_RENDER_FLAG
					displayColor.shaded = #material
				)
			)
		)
		
		fn updateToolbar =
		(
			(getToolbarItem "+").enabled = Prop.Base.canAdd
			(getToolbarItem "T").enabled = Prop.Base.canTimeUpdate
			(getToolbarItem "M").enabled = Prop.Base.materialsMode
		)
		
		fn setFilters list =
		(
			local filteredList = for filt in list where (Prop.getRowsByFilter filt).count > 1 collect filt
			
			(getStatusbarItem "Filter").Items.Clear()
			(getStatusbarItem "Filter").Items.AddRange (DN.dnArray filteredList)
		)
		
		fn refreshList =
		(
			Prop.init forced:true
			gridRows = Prop.getRows()
			
			updateGrid()
			updateToolbar()
			updateDisplay()
			setFilters (Prop.getFilters())
		)
		
		fn changeCategory sender arg =
		(
			if Prop != undefined and isProperty Prop #done then
				Prop.done()
			Prop = pluginStructs[sender.SelectedIndex + 1]
			Prop.init()
			refreshList()
			setFilters (Prop.getFilters())
			unRegisterTimeCallback rollout_AppDisplay.refreshList
			(getToolbarItem "T").Checked = false
		)
		
		fn preSave =
		(
			local mode = getDisplayMode()
			if mode != 0 then (
				setDisplayMode 0
				recoverObjectsData()
			)
			lastDisplayMode = mode
		)
		
		fn postSave =
		(
			local mode = getDisplayMode()
			if mode == 0 and lastDisplayMode != 0 then (
				setDisplayMode lastDisplayMode
				updateDisplay()
			)
			lastDisplayMode = mode
		)
		
		fn colorClicked sender arg =
		(
			if selection.count > 0 then (
				if arg.ColumnIndex == 2 then (
					Prop.setValue arg.RowIndex (selection as array)
					refreshList()
				)
			)
		)
		
		fn dgvObjectsGrid_CellBeginEdit arg =
		(
			enableaccelerators = false
			if Prop.Base.editLabels then
				dgvObjectsGrid.BeginEdit true
		)
		
		fn dgvObjectsGrid_CellParsing sender arg =
		(
			local newVal = arg.FormattedValue
			local oldVal = (DN.GetCell dgvObjectsGrid arg.ColumnIndex arg.RowIndex).value
			
			if newVal == "" then
				dgvObjectsGrid.CancelEdit()
			else if newVal != oldVal then
				Prop.setLabel arg.RowIndex newVal
		)
		
		fn dgvObjectsGrid_SelectionChanged sender arg =
		(
			case getDisplayMode() of
			(
				2: if getDisplayMode() == 2 and not Prop.Base.materialsMode then setDisplayMode 0
				3: updateDisplay()
				default: ()
			)
		)
		
		fn addRow =
		(
			Prop.addRow()
			refreshList()
			dgvObjectsGrid.ClearSelection()
			dgvObjectsGrid.Rows.Item[Prop.Base.Rows.count - 1].Selected = true
			dgvObjectsGrid.FirstDisplayedScrollingRowIndex = dgvObjectsGrid.SelectedRows.item[0].Index
		)
		
		fn selectRows =
		(
			local rowIndexes = DN.GetSelectedRows dgvObjectsGrid
			local newSelection = #()
			for i in rowIndexes do
				newSelection = join newSelection Prop.Base.Rows[i + 1].objs
			select newSelection
		)
		
		fn FilterRows sender arg =
		(
			dgvObjectsGrid.ClearSelection()
			
			for i in (Prop.getRowsByFilter sender.SelectedItem) do
				dgvObjectsGrid.Rows.Item[i - 1].Selected = true
		)
		
		fn getImagesPath shortNames =
		(
			for i in shortNames collect iconsPath + i
		)
		
		fn initUIControls =
		(
			iconsList = DN.ImageList (getImagesPath icons) Width:16 Height:16
			
			strpControlsItems = #(
				DN.ToolBarItem title:"Select Category" kind:#ComboBox list:CATEGORIES,
				DN.ToolBarItem title:"Separator1" kind:#Separator,
				DN.ToolBarItem title:"V" kind:#Button check:true tooltip:"Toggle display" checked:false image:iconsList.images.Item[0] displayStyle:DN.c_ToolItemDisplayStyle.Image,
				DN.ToolBarItem title:"M" kind:#Button check:true tooltip:"Toggle materials" checked:false image:iconsList.images.Item[1] displayStyle:DN.c_ToolItemDisplayStyle.Image,
				DN.ToolBarItem title:"I" kind:#Button check:true tooltip:"Toggle identity" checked:false image:iconsList.images.Item[2] displayStyle:DN.c_ToolItemDisplayStyle.Image,
				DN.ToolBarItem title:"Separator2" kind:#Separator,
				DN.ToolBarItem title:"R" kind:#Button check:false tooltip:"Refresh list" image:iconsList.images.Item[3] displayStyle:DN.c_ToolItemDisplayStyle.Image,
				DN.ToolBarItem title:"S" kind:#Button check:false tooltip:"Select in scene" image:iconsList.images.Item[4] displayStyle:DN.c_ToolItemDisplayStyle.Image,
				DN.ToolBarItem title:"+" kind:#Button check:false tooltip:"Add a new row" enabled:false image:iconsList.images.Item[5] displayStyle:DN.c_ToolItemDisplayStyle.Image,
				DN.ToolBarItem title:"T" kind:#Button check:true tooltip:"Toggle time update" enabled:false image:iconsList.images.Item[6] displayStyle:DN.c_ToolItemDisplayStyle.Image
			)
			
			strpStatusBarItems = #(
				DN.ToolBarItem title:"Filter" kind:#ComboBox,
				DN.ToolBarItem title:"Prograss" kind:#ProgressBar
			)
			
			strpControls = DN.ToolBar tbItems:strpControlsItems 
			strpStatusBar = DN.StatusBar sItems:strpStatusBarItems
			
			initColumns()
			gridRows = #()
			
			dgvObjectsGrid = DN.GridView virtual:true Dock:DN.c_DockStyle.Fill AutoSizeCols:DN.c_GridAutoSizeCols.Fill
			DN.InitToolBarContainer tscMainWrapper Dock:DN.c_DockStyle.Fill ContentPanel:dgvObjectsGrid TopPanel:strpControls BottomPanel:strpStatusBar
			dgvObjectsGrid.EditMode = DN.c_GridEditMode.EditProgrammatically
			dgvObjectsGrid.AutoSizeRowsMode = DN.c_GridAutoSizeRows.DisplayedCells
			dgvObjectsGrid.DefaultCellStyle.WrapMode = DN.c_GridTriState.True
			
			for c in gridColumns do
				DN.GridAddColumn dgvObjectsGrid c.title kind:c.kind type:c.type width:c.width flatStyle:c.flatStyle
			
			dotNet.addEventHandler dgvObjectsGrid "CellValueNeeded" dgvObjectsGrid_CellValueNeeded
			dotNet.addEventHandler dgvObjectsGrid "CellValuePushed" dgvObjectsGrid_CellValuePushed
			dotNet.addEventHandler dgvObjectsGrid "CellContentDoubleClick" dgvObjectsGrid_CellBeginEdit
			dotNet.addEventHandler dgvObjectsGrid "CellValidating" dgvObjectsGrid_CellParsing
			dotNet.addEventHandler dgvObjectsGrid "SelectionChanged" dgvObjectsGrid_SelectionChanged
			dotNet.addEventHandler dgvObjectsGrid "CellContentClick" colorClicked
			
			dotNet.addEventHandler (getStatusbarItem "Filter") "SelectedIndexChanged" FilterRows
			
			dotNet.addEventHandler (getToolbarItem "Select Category") "SelectedIndexChanged" changeCategory
			dotNet.addEventHandler (getToolbarItem "V") "CheckedChanged" toggleDisplay
			dotNet.addEventHandler (getToolbarItem "M") "CheckedChanged" toggleMaterials
			dotNet.addEventHandler (getToolbarItem "I") "CheckedChanged" toggleIdentity
			dotNet.addEventHandler (getToolbarItem "R") "Click" refreshList
			dotNet.addEventHandler (getToolbarItem "S") "Click" selectRows
			dotNet.addEventHandler (getToolbarItem "+") "Click" addRow
			dotNet.addEventHandler (getToolbarItem "T") "CheckedChanged" toggleTimeUpdate
			
			updateGrid()
		)
		
		fn loadPlugins =
		(
			local pluginFiles = sort (getFiles (pluginsPath + "*.ms"))
			pluginStructs = #()
			CATEGORIES = #()
			
			for f in pluginFiles do (
				local pluginName = getFilenameFile f
				local pluginStruct = fileIn f
				append CATEGORIES pluginName
				append pluginStructs pluginStruct
			)
		)
		
		fn resizeRoll arg =
		(
			ROLL_WIDTH = arg.x
			ROLL_HEIGHT = arg.y
			tscMainWrapper.height = ROLL_HEIGHT - 25
			tscMainWrapper.width = ROLL_WIDTH
			sbLink.pos = [10, arg.y - 20]
			matanLink.pos = [arg.x - 100, arg.y - 20]
		)
		
		fn changeRolloutIcon roll icon =
		(
			if doesFileExist icon then (
				if classOf roll != String then
					roll = roll.title
				local d = (windows.getChildHWND 0 roll)[1]
				local WM_SETICON = 0x0080
				local ICON_SMALL = 0
				local icon = dotnetobject "System.Drawing.Icon" icon
				windows.SendMessage d WM_SETICON ICON_SMALL icon.handle
			)
		)
		
		fn openDialog =
		(
			createDialog rollout_AppDisplay width:ROLL_WIDTH height:ROLL_HEIGHT style:ROLL_STYLE pos:[100,100]
		)
		
		fn init =
		(
			changeRolloutIcon rollout_AppDisplay (getDir #userIcons + "\\sbLogo.ico")
			
			callbacks.addScript #filePreSave "rollout_AppDisplay.preSave()" id:#sb_appdisplay_callbacks
			callbacks.addScript #filePostSave "rollout_AppDisplay.postSave()" id:#sb_appdisplay_callbacks
			loadPlugins()
			Prop = s_prop_Default()
			saveObjectsData()
			initUIControls()
			resizeRoll [ROLL_WIDTH, ROLL_HEIGHT]
		)
	
		fn done =
		(
			local dispMode = getDisplayMode()
			if dispMode != 0 then
				recoverObjectsData mats:(dispMode == 2)
			
			unRegisterTimeCallback rollout_AppDisplay.refreshList
			callbacks.removeScripts id:#sb_appdisplay_callbacks
			
			gc light:true
		)
	
	-- Event Handlers
	------------------------------------------
	
		on rollout_AppDisplay resized arg do resizeRoll arg
		on rollout_AppDisplay open do init()
		on rollout_AppDisplay close do done()
	
	) -- end of rollout
	
	rollout_AppDisplay.openDialog()
)