(
	local tempDir = (getDir #temp) + "\\AppDisplay\\"
	local tempIconsDir = tempDir + "Icons\\"
	local tempModulsDir = tempDir + "Moduls\\"
	local tempUIDir = tempDir + "UI\\"
	local snowballToolsDir = (getDir #userScripts) + "\\Snowball_Tools\\"
	local scriptDir = snowballToolsDir + "AppDisplay\\"
	local modulsDir = scriptDir + "Moduls\\"
	local uiDir = scriptDir + "UI\\"
	local macosDir = getDir #userMacros + "\\"
	local iconsDir = getDir #userIcons + "\\"
	local scriptFile = "AppDisplay.ms"
	local macroFile = "AppDisplay.mcr"
	local iconFiles = for f in (getFiles (tempIconsDir + "*")) collect filenameFromPath f
	local moduls = for f in (getFiles (tempModulsDir + "*")) collect filenameFromPath f
	local uiFiles = for f in (getFiles (tempUIDir + "*")) collect filenameFromPath f
	
	fn deleteDirTree dir =
	(
		local subDirs = getDirectories (dir + "*")
		for sub in subDirs do
			deleteDirTree sub
		
		local files = getFiles (dir + "*")
		for f in files do
			deleteFile f
		
		deleteFile dir
	)
	
	fn cleanTempFiles =
	(
		deleteDirTree tempDir
	)
	
	fn uninstallOldVersion =
	(
		if doesFileExist scriptDir then
			deleteDirTree scriptDir
		
		for f in iconFiles where doesFileExist (iconsDir + f) do
			deleteFile (iconsDir + f)
	)
	
	fn installTool =
	(
		if not doesFileExist snowballToolsDir then
			makeDir snowballToolsDir
		
		makeDir scriptDir
		makeDir modulsDir
		makeDir uiDir
		
		copyFile (tempDir + scriptFile) (scriptDir + scriptFile)
		
		for f in iconFiles do 
			copyFile (tempIconsDir + f) (iconsDir + f)
		
		for f in moduls do
			copyFile (tempModulsDir + f) (modulsDir + f)
		
		for f in uiFiles do
			copyFile (tempUIDir + f) (uiDir + f)
		
		fileIn (tempDir + macroFile)
		colorman.reInitIcons()
		macros.run "Snowball VFX" "AppDisplay"
	)
	
	uninstallOldVersion()
	installTool()
	cleanTempFiles()
)