struct s_prop_Class
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	supClasses = #(),
	
	fn getFilters =
	(
		for o in supClasses collect o as string
	),
	
	fn getRowsByFilter filt =
	(
		for i = 1 to Base.Rows.count where isKindOf (execute Base.Rows[i].val) (execute filt) collect i
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.Rows = #()
			
			local classes = #()
			for o in objs do (
				local n = (classof o) as string
				appendIfUnique supClasses (superClassof o)
				appendIfUnique classes n
			)
			sort classes
			
			for i = 1 to classes.count do (
				local newRow = rollout_AppDisplay.s_rowData rowLabel:(classes[i] as string) val:classes[i]
				maxOps.colorByID (i - 1) &newRow.keyColor
				append Base.Rows newRow
			)
			
			for o in objs do (
				local n = findItem classes ((classof o) as string)
				if n == 0 then n = 1
				append Base.Rows[n].objs o
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		Base.setValue row objs
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_Class()