struct s_prop_DistanceFromSelection
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn getMinDistFromSelection obj =
	(
		local lastDist = 99999
		local newDist
		for o in selection where (newDist = distance o.pos obj.pos) < lastDist do
			lastDist = newDist
		lastDist
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.canTimeUpdate = true
			Base.gradColors = #(white, black)
			Base.inBetweens = 20
			Base.Rows = #()
			
			objs = for o in objs where not o.isHidden collect o
			
			local v = 0
			for i = 1 to Base.gradColors.count do (
				v += 1
				local newRow = rollout_AppDisplay.s_rowData rowLabel:(v as string) val:v keyColor:Base.gradColors[i]
				append Base.Rows newRow
				
				if i < Base.gradColors.count then (
					for j = 1 to Base.inBetweens do (
						v += 1
						local newRow = rollout_AppDisplay.s_rowData rowLabel:(v as string) val:v
						append Base.Rows newRow
					)
				)
			)
			
			Base.generateGrads()
			
			local distances = for o in objs collect getMinDistFromSelection o
			
			local maxDist = 0
			for d in distances where d > maxDist do
				maxDist = d
			
			for i = 1 to Base.Rows.count do
				Base.Rows[i].rowLabel = ((maxDist * i / Base.Rows.count) as integer) as string
			
			for i = 1 to objs.count do (
				local j
				if maxDist > 0.0 then
					j = ((ceil (Base.Rows.count * distances[i] / maxDist)) as integer) + 1
				else
					j = 1
				if j > Base.Rows.count then
					j = Base.Rows.count
				append Base.Rows[j].objs objs[i]
			)
			
			Base.Rows = for o in Base.Rows where o.objs.count > 0 collect o
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		Base.setValue row objs
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_DistanceFromSelection()