struct s_prop_HeirarchyDepth
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	gradColors = #(blue, green, yellow, red),
	inBetweens = 10,
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn generateGrads =
	(
		for i = 2 to Base.Rows.count - 1 do (
			if Base.Rows[i].keyColor == undefined then (
				local j = i - 1
				while(j > 1 and Base.Rows[j].keyColor == undefined) do
					j -= 1
				
				local k = i + 1
				while(k < Base.Rows.count and Base.Rows[k].keyColor == undefined) do
					k += 1
				
				Base.Rows[i].keyColor = 1.0 * Base.Rows[j].keyColor * (k - i) / (k - j) + 1.0 * Base.Rows[k].keyColor * (i - j) / (k - j)
				Base.Rows[i].keyColor.a = 255
			)
		)
	),
	
	fn round x =
	(
		if x - (floor x) < 0.5 then floor x else ceil x
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.Rows = #()
			if objs.count > 0 then (
				local currentObjs = for o in objs where o.parent == undefined collect o
				local i = 1
				
				while currentObjs.count > 0 do (
					local newRow = rollout_AppDisplay.s_rowData rowLabel:(i as string) val:i objs:currentObjs
					append Base.Rows newRow
					i += 1
					local nextObjs = #()
					for o in currentObjs do join nextObjs o.children
					currentObjs = nextObjs
				)
				
				if Base.Rows.count > 0 then
					Base.Rows[1].keyColor = black
				
				if Base.Rows.count > 1 then (
					Base.Rows[2].keyColor = gradColors[1]
					Base.Rows[Base.Rows.count].keyColor = gradColors[gradColors.count]
				)
				
				for i = 2 to gradColors.count - 1 do (
					if Base.Rows.count > 1 + i then (
						local j = round (1.0 + 1.0 * (Base.Rows.count - 1) * (i - 1) / (gradColors.count - 1)) as integer
						Base.Rows[j].keyColor = gradColors[i]
					)
				)
				
				generateGrads()
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_HeirarchyDepth()