struct s_prop_Layers 
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.editLabels = true
			Base.canAdd = true
			Base.Rows = #()
			local layers = #()
			
			for i = 1 to LayerManager.count do (
				local newRow = rollout_AppDisplay.s_rowData rowLabel:(LayerManager.getLayer (i - 1)).name val:(LayerManager.getLayer (i - 1))
				maxOps.colorByID (i - 1) &newRow.keyColor
				append layers newRow.val
				append Base.Rows newRow
			)
			
			for o in objs do
				append Base.Rows[findItem layers o.layer].objs o
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		local newRows = #()
		if Base.Rows.count > 0 then (
			for r = 1 to Base.Rows.count do (
				append newRows #()
				append newRows[r] Base.Rows[r].rowLabel
				append newRows[r] Base.Rows[r].objs.count
				append newRows[r] Base.Rows[r].keyColor
			)
		)
		
		newRows
	),
	
	fn setValue row objs =
	(
		row += 1
		
		for o in objs do
			Base.Rows[row].val.addnode o
	),
	
	fn addRow =
	(
		local newLayer = LayerManager.newLayer()
		for o in selection do
			newLayer.addnode o
	),
	
	fn setLabel row newLabel =
	(
		Base.Rows[row + 1].rowLabel = newLabel
		Base.Rows[row + 1].val.setname newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_Layers()