struct s_prop_NumChildren
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	gradColors = #(blue, green, yellow, red),
	inBetweens = 10,
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn generateGrads =
	(
		for i = 2 to Base.Rows.count - 1 do (
			if Base.Rows[i].keyColor == undefined then (
				local j = i - 1
				while(j > 1 and Base.Rows[j].keyColor == undefined) do
					j -= 1
				
				local k = i + 1
				while(k < Base.Rows.count and Base.Rows[k].keyColor == undefined) do
					k += 1
				
				Base.Rows[i].keyColor = 1.0 * Base.Rows[j].keyColor * (k - i) / (k - j) + 1.0 * Base.Rows[k].keyColor * (i - j) / (k - j)
				Base.Rows[i].keyColor.a = 255
			)
		)
	),
	
	fn getNumOfChildren obj objs objList objChildren =
	(
		local n = obj.children.count
		if n > 0 then (
			for i in obj.children do (
				local arr = getNumOfChildren i objs objList objChildren
				objs = arr[1]
				objList = arr[2]
				objChildren = arr[3]
				n += arr[3][arr[3].count]
			)
		)
		
		local a = findItem objs obj
		if a > 0 then
			deleteItem objs a
		
		append objList obj
		append objChildren n
		#(objs, objList, objChildren)
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.Rows = #()
			if objs.count > 0 then (
				local objNumChildren = #()
				local objList = #()
				local maxChildren = 0
				local lastColor
				
				while (objs.count > 0) do (
					local arr = getNumOfChildren objs[1] (objs as array) objList objNumChildren
					objs = arr[1]
					objList = arr[2]
					objChildren = arr[3]
					
					if objChildren[objChildren.count] > maxChildren then
						maxChildren = objChildren[objChildren.count]
				)
				
				for i = 1 to maxChildren + 1 do (
					local newColor = if i == 1 then
						black
					else 
						gradColors[i * (gradColors.count - 1) / (maxChildren + 1) + 1]
					
					local newRow = rollout_AppDisplay.s_rowData rowLabel:(i as string) val:i
					if lastColor != newColor then
						newRow.keyColor = newColor
					
					append Base.Rows newRow
					lastColor = newColor
				)
				
				generateGrads()
				
				for i = 1 to objList.count do
					append Base.Rows[objNumChildren[i] + 1].objs objList[i]
				
				Base.Rows = for row in Base.Rows where row.objs.count > 0 collect row
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_NumChildren()