struct s_prop_ObjectID
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn addCustAttribute =
	(
		if not isProperty globalTracks #AppDisplay_ObjectID then (
			local def = attributes AppDisplay_ObjectID
			(
				parameters ObjectID_Params
				(
					Labels type:#stringTab tabSizeVariable:true
					Values type:#intTab tabSizeVariable:true
				)
			)
			
			custAttributes.add globalTracks def
		)
	),
	
	fn addCustLabel newLabel val =
	(
		local n = findItem globalTracks.AppDisplay_ObjectID.Values val
		if n == 0 then (
			append globalTracks.AppDisplay_ObjectID.Values val
			append globalTracks.AppDisplay_ObjectID.Labels newLabel
		) else (
			globalTracks.AppDisplay_ObjectID.Values[n] = val
			globalTracks.AppDisplay_ObjectID.Labels[n] = newLabel
		)
	),
	
	fn getLabel val =
	(
		local n = findItem globalTracks.AppDisplay_ObjectID.Values val
		if n == 0 then
			"ID " + val as string
		else
			globalTracks.AppDisplay_ObjectID.Labels[n]
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.materialsMode = true
			Base.editLabels = true
			Base.canAdd = true
			Base.Rows = #()
			
			addCustAttribute()
			
			local objectIDs = #()
			for o in objs do
				appendIfUnique objectIDs o.gbufferChannel
			sort objectIDs
			
			for i in objectIDs do (
				local newRow = rollout_AppDisplay.s_rowData rowLabel:(getLabel i) val:i
				maxOps.colorByID i &newRow.keyColor
				append Base.Rows newRow
			)
			
			for o in objs do (
				local n = findItem objectIDs o.gbufferChannel
				append Base.Rows[n].objs o
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		row += 1
		
		for o in objs do
			o.gbufferChannel = Base.Rows[row].val
	),
	
	fn addRow =
	(
		local newVal = Base.Rows[Base.Rows.count].val + 1
		local newRow = rollout_AppDisplay.s_rowData rowLabel:("ID " + newVal as string) val:newVal
		maxOps.colorByID newVal &newRow.keyColor
		append Base.Rows newRow
		
		for o in selection do (
			o.gbufferChannel = newVal
			append Base.Rows[Base.Rows.count].objs o
		)
	),
	
	fn setLabel row newLabel =
	(
		addCustLabel newLabel Base.Rows[row + 1].val
	),
	
	fn createMaterials =
	(
		local re = maxOps.GetCurRenderElementMgr()
		
		for r = 1 to Base.Rows.count do (
			local id = Base.Rows[r].val
			re.addRenderElement (MatteRenderElement elementName:("Matte - " + (getLabel id)) gbufIDOn:true gbufID:id)
		)
		
		/*
		for r = 1 to Base.Rows.count do (
			local idMat = standard()
			local idColor
			idMat.selfIllumAmount = 100
			maxOps.colorByID Base.Rows[r].val &idColor
			idMat.Diffuse = idColor
			idMat.ambient = idColor
			Base.Rows[r].objs.material = idMat
			Base.Rows[r].objs.renderable = Base.Rows[r].renderable
		)
		*/
	)
)

s_prop_ObjectID()