struct s_prop_RenderSettings
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn getObjectCombo obj =
	(
		local combo = #()
		for i = 1 to Base.flags.count do (
			local test = case i of
			(
				1: obj.renderable
				2: obj.inheritVisibility
				3: obj.primaryVisibility
				4: obj.secondaryVisibility
				5: obj.receiveShadows
				6: obj.castShadows
				7: obj.applyAtmospherics
				8: obj.renderOccluded
				default: false
			)
			if not test then append combo Base.flags[i]
		)
		
		combo
	),
	
	fn findArrayItem arr1 arr2 = 
	(
		local n = 0
		for i = 1 to arr1.count do (
			if arr1[i].count != arr2.count then
				exit
			else (
				n = i
				for j = 1 to arr2.count do
					if arr2[j] != arr1[i][j] then
						exit with n = 0
				if n != 0 then
					exit
			)
		)
		n
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.flags = #(
				"Renderable",
				"Inherit Visibility",
				"Visible to Camera",
				"Visible to Reflection/Refraction",
				"Receive Shadows",
				"Cast Shadows",
				"Apply Atmospherics"
			)
			
			Base.Rows = #()
			local combos = #()
			
			fn sortFN r1 r2 =
			(
				local c1 = r1.val
				local c2 = r2.val
				
				case of
				(
					(c1.count > c2.count): 1
					(c1.count < c2.count): -1
					default: (
						local a, b
						for i = 1 to c1.count do (
							if c1[i] != c2[i] then (
								a = findItem Base.flags c1[i]
								b = findItem Base.flags c2[i]
								exit
							)
						)
						
						case of
						(
							(a > b): 1
							(a < b): -1
							default:0
						)
					)
				)
			)
			
			for o in objs do (
				local objCombo = getObjectCombo o
				local n = findArrayItem combos objCombo
				
				if n == 0 then (
					append combos objCombo
					
					local newLabel = "Not: "
					if objCombo.count == 0 then
						newLabel = "All"
					else if objCombo.count == Base.flags.count then
						newLabel = "None"
					else
						for i = 1 to objCombo.count do
							newLabel += objCombo[i] as string + (if i < objCombo.count then ", " else "")
					
					local newRow = rollout_AppDisplay.s_rowData rowLabel:newLabel val:objCombo objs:#(o)
					maxOps.colorByID (combos.count - 1) &newRow.keyColor
					append Base.Rows newRow
				) else
					append Base.Rows[n].objs o
			)
			
			qsort Base.Rows sortFN
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setCombo obj combo =
	(
		for i = 1 to Base.flags.count do (
			local test = findItem combo Base.flags[i] == 0
			
			case i of
			(
				1: obj.renderable = test
				2: obj.inheritVisibility = test
				3: obj.primaryVisibility = test
				4: obj.secondaryVisibility = test
				5: obj.receiveShadows = test
				6: obj.castShadows = test
				7: obj.applyAtmospherics = test
				8: obj.renderOccluded = test
				default: ()
			)
		)
	),
	
	fn setValue row objs =
	(
		row += 1
		
		for o in objs do
			setCombo o Base.Rows[row].val
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_RenderSettings()