struct s_prop_TurbosmoothIterations
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	gradColors = #(blue, green, red),
	inBetweens = 10,
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn getTurboIterations obj =
	(
		local i = 0
		for m in obj.modifiers where isKindOf m turbosmooth do (
			if m.useRenderIterations then
				i += m.renderIterations
			else
				i += m.iterations
		)
		i
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.Rows = #()
			
			
			if objs.count > 0 then (
				for o in objs do (
					local i = getTurboIterations o
					
					if Base.Rows.count < i + 1 then
						for j = Base.Rows.count + 1 to i + 1 do
							append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:(i as string) val:i)
					
					append Base.Rows[i + 1].objs o
				)
				
				if Base.Rows.count > 0 then
					Base.Rows[1].keyColor = black
				
				if Base.Rows.count > 1 then
					Base.Rows[2].keyColor = gradColors[1]
				
				if Base.Rows.count > 2 then
					Base.Rows[Base.Rows.count].keyColor = gradColors[3]
				
				if Base.Rows.count > 3 then
					Base.Rows[(Base.Rows.count * 0.5) as integer + 1].keyColor = gradColors[2]
				
				Base.generateGrads()
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		Base.setValue row objs
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_TurbosmoothIterations()