struct s_prop_VertexDensity
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	gradColors = #(blue, green, red),
	inBetweens = 10,
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn generateGrads =
	(
		for i = 1 to Base.Rows.count do (
			if Base.Rows[i].keyColor == undefined then (
				local j = i - 1
				while(Base.Rows[j].keyColor == undefined and j > 1) do
					j -= 1
				
				local k = i + 1
				while(Base.Rows[k].keyColor == undefined and k < Base.Rows.count) do
					k += 1
				
				Base.Rows[i].keyColor = Base.Rows[j].keyColor * (k - i) / (k - j) + Base.Rows[k].keyColor * (i - j) / (k - j)
			)
		)
	),
	
	fn getObjDens obj =
	(
		if isProperty obj #mesh and isProperty obj.mesh #numVerts then (
			local bb = nodeLocalBoundingBox obj
			(obj.mesh.numVerts * 10 / (distance bb[1] bb[2])) as integer
		) else
			-1
	),
	
	fn init objs:objects forced:false =
	(
		if not Base.initialized or forced then (
			Base.Rows = #()
			if objs.count > 0 then (
				local count = (gradColors.count - 1) * inBetweens
				local vertDensArr = #()
				
				for o in objs do
					append vertDensArr (getObjDens o)
				local maxDens = sort (copy vertDensArr #noMap)
				maxDens = maxDens[maxDens.count]
				
				append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"Non Geometry" keyColor:black val:-1)
				for i = 1 to gradColors.count do (
					local v = (i - 1) * inBetweens
					local minVal = v * maxDens / (count + 1)
					local maxVal = (v + 1) * maxDens / (count + 1)
					local newLabel = minVal as string + " -> " + maxVal as string
					local newRow = rollout_AppDisplay.s_rowData rowLabel:newLabel keyColor:gradColors[i] val:maxVal
					append Base.Rows newRow
					
					if i < gradColors.count then (
						for j = 1 to inBetweens - 1 do (
							minVal = (v + j) * maxDens / (count + 1)
							maxVal = (v + j + 1) * maxDens / (count + 1)
							newLabel = minVal as string + " -> " + maxVal as string
							newRow = rollout_AppDisplay.s_rowData rowLabel:newLabel val:maxVal
							append Base.Rows newRow
						)
					)
				)
				
				generateGrads()
				
				for i = 1 to objs.count do (
					if vertDensArr[i] < 0 then
						append Base.Rows[1].objs objs[i]
					else (
						for j = 2 to Base.Rows.count do (
							if Base.Rows[j].val >= vertDensArr[i] then (
								append Base.Rows[j].objs objs[i]
								exit
							)
						)
					)
				)
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		row += 1
		
		for o in objs do ()
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		Base.setLabel row newLabel
	),
	
	fn createMaterials =
	(
		Base.createMaterials()
	)
)

s_prop_VertexDensity()